<template>
  <form class="form" @submit="onSubmit">
    <Select label="استان" id="state" :dark="!light" class="field" :options="states" v-model="state"/>
    <Select label="شهر" id="city" :dark="!light" class="field" :options="cities" v-model="city"/>
    <TextField v-model="addressText" :dark="!light" inputType="text" label="آدرس" id="address" class="field" :error="addressError" />
    <TextField v-model="zipcode" :dark="!light" inputType="text" label="کد پستی" id="zipcode" class="field" :error="zipcodeError" />
    <TextField v-model="name" :dark="!light" inputType="text" label="نام و نام خانوادگی تحویل گیرنده" id="name" class="field" :error="nameError" />
    <TextField v-model="phone" :dark="!light" inputType="tel" label="تلفن همراه تحویل گیرنده" id="phone" class="field" :error="phoneError" />
    <Button v-if="selfCreate" type="contained" size="lg" class="submit-button" @click.native="onSubmit">{{ buttonText }}</Button>
  </form>
</template>

<script>
import Button from "@/components/base/Button";
import Select from "@/components/base/Select";
import TextField from "@/components/base/TextField";

export default {
  name: "AddressForm",
  components: {
    Button,
    Select,
    TextField
  },
  data() {
    return {
      id: this.address ? this.address.id : undefined,
      addressText: this.address ? this.address.address : '',
      zipcode: this.address ? this.address.zipcode : '',
      name: this.address ? this.address.receiverName : '',
      phone: this.address ? this.address.phone : '',
      state: this.address ? { title: this.address.state } : {},
      city: this.address ? { title: this.address.city } : {},
      cities: this.stateCities || []
    }
  },
  props: {
    address: {
      type: Object,
      default: null
    },
    states: {
      type: Array,
      required: true
    },
    stateCities: {
      type: Array,
      default: undefined
    },
    light: {
      type: Boolean,
      default: false
    },
    selfCreate: {
      type: Boolean,
      default: true
    }
  },
  methods: {
    onSubmit(e) {
      e.preventDefault();
      if (!this.selfCreate) {
        return;
      }
      if (this.id) {
        this.update()
      } else {
        this.createAddress();
      }
    },
    createAddress() {
      if (this.canCreateAddress) {
        const info = {
          data: {
            address: this.addressText,
            state: this.state.title,
            city: this.city.title,
            phone: this.phone,
            receiver_name: this.name,
            zipcode: this.zipcode,
            default: false
          },
          token: this.$store.getters['auth/getToken']
        };
        this.$store.dispatch('addresses/createAddress', info).then(response => {
          if (response.status === 201) {
            this.$store.dispatch('notifications/push', {
              message: 'آدرس با موفقیت ایجاد شد.',
              light: true,
              type: 'success',
              timeout: 2500
            });
            this.$router.push('/dashboard/addresses');
          } else {
            this.$store.dispatch('notifications/push', {
              message: 'لطفا ورودی های خود را کنترل کنید!',
              type: 'error',
              timeout: 2500
            });
          }
        }).catch(error => {
          this.$store.dispatch('notifications/push', {
            message: 'خطا در اتصال به سرور. دقایقی دیگر دوباره تلاش کنید.',
            type: 'error',
            timeout: 3500
          });
        });
      } else {
        this.$store.dispatch('notifications/push', {
          message: 'لطفا ورودی های خود را کنترل کنید!',
          light: true,
          type: 'warning',
          timeout: 2500
        });
      }
    },
    update() {
      if (this.canUpdateAddress) {
        const info = {
          data: {
            address: this.addressText,
            state: this.state.title,
            city: this.city.title,
            phone: this.phone,
            receiver_name: this.name,
            zipcode: this.zipcode,
            default: false
          },
          id: this.id,
          token: this.$store.getters['auth/getToken']
        };
        this.$store.dispatch('addresses/updateAddress', info).then(response => {
          if (response.status === 200) {
            this.$store.dispatch('notifications/push', {
              message: 'آدرس با موفقیت بروزرسانی شد.',
              light: true,
              type: 'success',
              timeout: 2500
            });
            this.$router.push('/dashboard/addresses');
          } else {
            this.$store.dispatch('notifications/push', {
              message: 'لطفا ورودی های خود را کنترل کنید!',
              type: 'error',
              timeout: 2500
            });
          }
        }).catch(error => {
          this.$store.dispatch('notifications/push', {
            message: 'خطا در اتصال به سرور. دقایقی دیگر دوباره تلاش کنید.',
            type: 'error',
            timeout: 3500
          });
        });
      } else {
        this.$store.dispatch('notifications/push', {
          message: 'لطفا ورودی های خود را کنترل کنید!',
          light: true,
          type: 'warning',
          timeout: 2500
        });
      }
    }
  },
  watch: {
    selectedStateId() {
      if (!this.selectedStateId) {
        return [];
      }
      this.$store.dispatch('addresses/fetchState', this.selectedStateId).then(response => {
        if (response.status === 200) {
          this.cities = response.data.data.cities;
        }
      }).catch(error => {
        console.log(error);
      });
    },
    canCreateAddress() {
      if (this.canCreateAddress) {
        const data = {
          address: this.addressText,
          state: this.state.title,
          city: this.city.title,
          phone: this.phone,
          receiver_name: this.name,
          zipcode: this.zipcode,
          default: false
        };
        this.$emit('change', data);
      }
    }
  },
  computed: {
    getCitiesTitles() {
      return this.cities.map(cur => cur.title);
    },
    selectedStateId() {
      if (!this.state) {
        return null
      }
      return this.state.id;
    },
    getStateTitles() {
      if (this.states) {
        return this.states.map(cur => cur.title);
      }
      return [];
    },
    buttonText() {
      return this.address ? 'بروزرسانی' : 'ثبت';
    },
    phoneError() {
      const regex = /^(\+98|0)?9\d{9}$/;
      if (!this.phone) {
        return "";
      } else if (!regex.test(this.phone)) {
        return "شماره موبایل وارد شده معتبر نمی باشد!";
      } else {
        return "";
      }
    },
    nameError() {
      const regex = /^[آ-ی ء چ]+$/;
      if (!this.name) {
        return "";
      } else if (!regex.test(this.name)) {
        return "فقط از حروف فارسی استفاده کنید!";
      } else {
        return "";
      }
    },
    zipcodeError() {
      const regex = /^\d{10}$/;
      if (!this.zipcode) {
        return "";
      } else if (!regex.test(this.zipcode)) {
        return "کد پستی باید 10 رقم باشد!";
      } else {
        return "";
      }
    },
    addressError() {
      const regex = /^([آ-ی ء چ]|[-,،.]|[0-9])+$/;
      if (!this.addressText) {
        return ""
      } else if (!regex.test(this.addressText)) {
        return "فقط حروف فارسی، عدد و علائم - , ، مجاز می باشند!"
      } else {
        return ""
      }
    },
    isFormFilled() {
      return this.state && this.city && this.addressText && this.zipcode && this.name && this.phone ? 
        true : false;
    },
    isFormValid() {
      return !this.nameError && !this.zipcodeError && !this.phoneError && this.city.title && this.state.title && !this.addressError ? true : false;
    },
    canCreateAddress() {
      return this.isFormFilled && this.isFormValid ? true : false;
    },
    canUpdateAddress() {
      return this.canCreateAddress;
    }
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables"

.field
  &:not(:last-child)
    margin-bottom $md

.submit-button
  width 100%

</style>